<template>
    <AdminMenuBar>
        <el-card>
            <div class="flex">
                <el-button class="margin-right-sm" type="success" size="large" @click="() => router.push('create')"
                    >Add product</el-button
                >
                <el-input
                    class="margin-right-sm"
                    placeholder="Search certain food"
                    v-model="searchQuery"
                    size="large"
                ></el-input>

                <el-select
                    class="margin-right-sm"
                    v-model="availability"
                    size="large"
                >
                    <el-option label="All products" value="all"></el-option>
                    <el-option label="Available" value="available"></el-option>
                    <el-option label="Not available" value="not_available"></el-option>
                </el-select>

                <el-select
                    v-model="sortOrder"
                    size="large"
                >
                    <el-option label="A to Z" value="asc"></el-option>
                    <el-option label="Z to A" value="desc"></el-option>
                </el-select>
            </div>
        </el-card>
        <el-card v-loading="loading" class="margin-top-sm">
            <h2 v-if="data.length < 1" style="text-align:center; color:var(--el-color-info)">No data</h2>
            <el-row :gutter="10" class="flex items-center items-justify flex-wrap gap-md">
                <template v-for="item in sortedItems">
                    <el-card
                        class="food-card margin-top-sm"
                        :body-style="{ padding: '0px' }"
                    >
                        <p class="not-available" v-if="!item.available">Not available</p>
                        <img
                                :src="
                                    item.img_url.length > 0
                                        ? `/pictures/${item.img_url}`
                                        : `/imgs/logo.jpg`
                                "
                            />
                        <p class="food-price">₱{{ item.price }}</p>

                        <h3 class="food-name">{{ item.name }}</h3>
                        <p class="food-description">
                                        {{ item.quantity}} PIECES
                                        </p>
                        <p class="food-description">{{ item.description }}</p>
                        <div class="buttons">
                            <el-button
                                class="update-button"
                                type="success"
                                size="large"
                                @click="router.push(`update/${item.id}`)"
                                >Update</el-button
                            >
                            <el-button
                                class="delete-button"
                                type="danger"
                                size="large"
                                @click="deleteProduct(item.id, item.name)"
                                >Delete</el-button
                            >
                        </div>
                    </el-card>
                </template>
            </el-row>
        </el-card>
    </AdminMenuBar>
</template>

<style lang="scss" scoped>
@import "../../../../sass/app.scss";

.not-available {
    font-size:1rem;
    padding:0.3rem 1rem;
    position: absolute;
    margin: 0 auto;
    background-color: rgb(253, 47, 47);
    border:1px solid rgb(131, 131, 131);
    border-radius: 1rem;
    color: white;
    font-family: impact;
    transform: rotate(-20deg);
}

.responsive-row {
    display: flex;
    align-items: center;
    justify-content: center;
    gap: 1px;
}

.food-card {
    background-color: #f1f1f1;
    box-shadow: rgba(0, 0, 0, 0.16) 0px 3px 6px, rgba(0, 0, 0, 0.23) 0px 3px 6px;
    color: black;
    border-radius: 8px;
    padding: 20px;
    text-align: center;
    width: 250px;
    height: 360px;
    position: relative;
}

.food-card img {
    width: 100%;
    height: 200px;
    object-fit: cover;
    border-radius: 8px;
    margin-bottom: 10px;
}

.food-name {
    font-size: 1.1rem;
    margin: 0px;
    text-align: left;
}

.food-description {
    font-size: 1rem;
    margin: 0px;
    margin-bottom: 10px;
    text-align: left;
    width: 450px;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
}

.food-price {
    margin: 0px;
    font-size: 1.5rem;
    padding: 0.5rem;
    border: 1px solid rgb(66, 66, 66);
    border-radius: 100%;
    font-weight: bold;
    font-family: Impact, Haettenschweiler, "Arial Narrow Bold", sans-serif;
    text-align: left;
    transform: rotate(-20deg);
    position: absolute;
    top: 0;
    right: 0;
    margin-right: 1rem;
    margin-top: 1rem;
    background-color: var(--el-color-primary);
    color: white;
    text-shadow: 1px 1px 1px black;
}

.buttons {
    margin-top: 1rem;
}

.update-button,
.delete-button {
    padding: 8px 16px;
    font-size: 0.9rem;
    width: 6rem;
    border: none;
    border-radius: 4px;
    cursor: pointer;
}

.update-button {
    background-color: #4caf50;
    color: white;
    margin-right: 10px;
}

.delete-button {
    background-color: #f44336;
    color: white;
}

.el-button{
    color:white;
}
</style>

<script setup>
import { onMounted } from "vue";
import { ref, computed } from "vue";
import { ElMessage, ElMessageBox } from "element-plus";
import { useRouter } from "vue-router";
import itemHandler from "../../helpers/itemHandler";

const router = useRouter();
const data = ref([]);
const searchQuery = ref("");

const {loading, fetchItem, destroyItem} = itemHandler;
const URL_fetch_items = "/api/user/item";

onMounted(async () => {
    fetchItem(URL_fetch_items, data);
});

const deleteItem = async (id) => {
    const URL_destroy_item = "/api/user/item/" + id;
    await destroyItem(URL_destroy_item);
}

const deleteProduct = (id, name) => {
    ElMessageBox.confirm(`Are you sure you want to delete this product named: ${name}?`, {
        cancelButtonText: "Cancel",
        confirmButtonText: "OK",
        type: "warning",
    })
        .then(async () => {
            deleteItem(id);
            fetchItem(URL_fetch_items, data);
        })
        .catch(() => {
            ElMessage({
                type: "info",
                message: "Delete canceled",
            });
        });
}

const sortOrder = ref("asc");
const availability = ref("all");
const sortedItems = computed(() => {
    const filteredSortedItems = [...filteredItems.value].sort((a, b) => {
        const nameA = a.name.toLowerCase();
        const nameB = b.name.toLowerCase();
        if (sortOrder.value === "asc") {
            return nameA.localeCompare(nameB);
        } else {
            return nameB.localeCompare(nameA);
        }
    });

    if (availability.value === "available") {
        return filteredSortedItems.filter(item => item.available);
    } else if (availability.value === "not_available") {
        return filteredSortedItems.filter(item => !item.available);
    }

    return filteredSortedItems;
});


const filteredItems = computed(() => {
    if (!searchQuery.value) {
        return data.value; // Return all items if search query is empty
    } else {
        return data.value.filter((item) =>
            item.name.toLowerCase().includes(searchQuery.value.toLowerCase())
        );
    }
});
</script>
